<?php
/**
 * webEdition CMS
 *
 * $Rev: 15376 $
 * $Author: mokraemer $
 * $Date: 2018-06-19 20:40:15 +0200 (Tue, 19 Jun 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
require_once(WE_INCLUDES_PATH . 'we_tag.inc.php');

class we_editor_contentobject extends we_editor_base{

	public function show(){

		$uniquename = md5(uniqid(__FILE__, true));
		$we_transaction = we_base_request::_(we_base_request::TRANSACTION, 'we_transaction', 0);
//	---> Setting the Content-Type

		$this->charset = $this->we_doc->getElement('Charset', we_contents_base::ETYPE_TEXT, DEFAULT_CHARSET, true);
		$sort = $this->we_doc->getElement('we_sort', we_contents_base::ETYPE_TEXT);

//	---> Loading the Stylesheets
		$head = '';
		if($this->we_doc->CSS){
			$cssArr = id_to_path(explode(',', $this->we_doc->CSS), FILE_TABLE, null, true);
			foreach($cssArr as $path){
				$head .= we_html_element::cssLink($path);
			}
		}

		$content = '';

		foreach(array_keys($sort) as $identifier){
			$uniqid = "entry_" . $identifier;

			$content .= we_html_element::div(['id' => $uniqid, 'class' => "objectFileElement"], we_html_element::div(['id' => 'f' . $uniqid, 'class' => "default"], '<table>' .
						$this->we_doc->getFieldHTML($this->jsCmd, $this->we_doc->getElement('wholename' . $identifier), $uniqid, $we_transaction) .
						'</table>'/* .
						  we_html_element::span(['class' => "defaultfont clearfix", 'style' => "width:180px;"], we_html_button::create_button(we_html_button::ADD_FIELD, "javascript:we_cmd('object_insert_entry_at_class','" . $we_transaction . "','" . $uniqid . "');") .
						  we_html_button::create_button(we_html_button::DIRUP, "javascript:we_cmd('object_up_entry_at_class','" . $we_transaction . "','" . $uniqid . "');", '', '', false, false, "_" . $identifier) .
						  we_html_button::create_button(we_html_button::DIRDOWN, "javascript:we_cmd('object_down_entry_at_class','" . $we_transaction . "','" . $uniqid . "');", '', '', false, false, "_" . $identifier) .
						  we_html_button::create_button(we_html_button::TRASH, "javascript:we_cmd('object_delete_entry_at_class','" . $we_transaction . "','" . $uniqid . "');")
						  ) */
			));

			$this->jsCmd->addCmd('orderContainerAdd', $uniqid);
		}

		return $this->getPage($this->we_doc->getEmptyDefaultFields() . we_html_multiIconBox::addBoxContainer($uniquename, '', we_html_element::div(['id' => "orderContainer"]) . we_html_element::div([
						'id' => $uniquename . '_div',
						'style' => "margin:1ex 1em;"
						], we_html_button::create_button(we_html_button::ADD_FIELD, "javascript:_EditorFrame.setEditorIsHot(true);we_cmd('object_insert_entry_at_class','" . we_base_request::_(we_base_request::TRANSACTION, 'we_transaction') . "');")
				)) .
				$content, we_html_element::jsScript(JS_DIR . '/weOrderContainer.js') . $head, [
				'onload' => "doScrollTo();"
		]);
	}

}
