<?php

/**
 * webEdition CMS
 *
 * $Rev: 15093 $
 * $Author: mokraemer $
 * $Date: 2018-03-21 12:07:05 +0100 (Wed, 21 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_info_object extends we_editor_base{

	public function show(){

		$parts = [
			['headline' => 'ID',
				'html' => ($this->we_doc->ID ?: '-'),
				'icon' => we_html_multiIconBox::PROP_META,
				'noline' => true,
			],
			['headline' => g_l('weEditorInfo', '[content_type]'),
				'html' => g_l('weEditorInfo', '[' . $this->we_doc->ContentType . ']'),
				'space' => we_html_multiIconBox::SPACE_ICON,
				'rightHeadline' => true
			],
			['headline' => g_l('weEditorInfo', '[creation_date]'),
				'html' => date(g_l('weEditorInfo', '[date_format]'), $this->we_doc->CreationDate),
				'icon' => we_html_multiIconBox::INFO_CALENDAR,
				'noline' => true,
			],
			['headline' => g_l('modules_users', '[created_by]'),
				'html' => f('SELECT CONCAT(First," ",Second," (",username,")") FROM ' . USER_TABLE . ' WHERE ID=' . $this->we_doc->CreatorID),
				'space' => we_html_multiIconBox::SPACE_ICON,
				'noline' => true,
				'rightHeadline' => true,
				'hide' => empty($this->we_doc->CreatorID)
			],
			['headline' => g_l('weEditorInfo', '[changed_date]'),
				'html' => date(g_l('weEditorInfo', '[date_format]'), $this->we_doc->ModDate),
				'space' => we_html_multiIconBox::SPACE_ICON,
				'noline' => true,
				'rightHeadline' => true
			],
			['headline' => g_l('modules_users', '[changed_by]'),
				'html' => f('SELECT CONCAT(First," ",Second," (",username,")") FROM ' . USER_TABLE . ' WHERE ID=' . $this->we_doc->ModifierID),
				'space' => we_html_multiIconBox::SPACE_ICON,
				'noline' => true,
				'rightHeadline' => true,
				'hide' => empty($this->we_doc->ModifierID)
			],
		];
		return $this->getPage(we_html_multiIconBox::getHTML('', $parts, true), we_html_element::jsScript(JS_DIR . 'multiIconBox.js'));
	}

}
