<?php

/**
 * webEdition CMS
 *
 * $Rev: 15739 $
 * $Author: mokraemer $
 * $Date: 2018-09-10 22:01:47 +0200 (Mon, 10 Sep 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_objectTextarea extends we_editor_base{
	private $name = '';

	public function __construct(we_contents_root $we_doc, we_base_jsCmd $jsCmd = null, $we_transaction = ''){
		parent::__construct($we_doc, $jsCmd);
		$nr = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1);
		$this->name = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 2);

		if(we_base_request::_(we_base_request::BOOL, "ok")){
			$this->we_doc->setElement($this->name . 'inlineedit', (we_base_request::_(we_base_request::BOOL, 'inlineedit') ? 'on' : 'off'));
			$this->we_doc->setElement($this->name . 'forbidhtml', (we_base_request::_(we_base_request::BOOL, 'forbidhtml') ? 'on' : 'off'));
			$this->we_doc->setElement($this->name . 'removefirstparagraph', (we_base_request::_(we_base_request::BOOL, 'removefirstparagraph') ? 'on' : 'off'));
			$this->we_doc->setElement($this->name . 'xml', (we_base_request::_(we_base_request::BOOL, 'xml') ? 'on' : 'off'));
			$this->we_doc->setElement($this->name . 'dhtmledit', (we_base_request::_(we_base_request::BOOL, 'dhtmledit') ? 'on' : 'off'));
			$this->we_doc->setElement($this->name . 'showmenus', (we_base_request::_(we_base_request::BOOL, 'showmenus') ? 'on' : 'off'));
			$this->we_doc->setElement($this->name . 'commands', we_base_request::_(we_base_request::STRING, 'commands'));
			$this->we_doc->setElement($this->name . 'contextmenu', we_base_request::_(we_base_request::STRING, 'contextmenu'));
			$this->we_doc->setElement($this->name . 'height', we_base_request::_(we_base_request::INT, 'height', 50));
			$this->we_doc->setElement($this->name . 'width', we_base_request::_(we_base_request::INT, 'width', 200));
			$this->we_doc->setElement($this->name . 'bgcolor', we_base_request::_(we_base_request::STRING, 'bgcolor', ''));
			$this->we_doc->setElement($this->name . 'class', we_base_request::_(we_base_request::STRING, 'class', ''));
			$this->we_doc->setElement($this->name . 'cssClasses', implode(',', we_base_request::_(we_base_request::STRING_LIST, 'cssClasses', [])));
			$this->we_doc->setElement($this->name . 'fontnames', implode(',', we_base_request::_(we_base_request::STRING_LIST, 'fontnames', [])));
			$this->we_doc->setElement($this->name . 'fontsizes', implode(',', we_base_request::_(we_base_request::STRING_LIST, 'fontsizes', [])));
			$this->we_doc->setElement($this->name . 'formats', implode(',', we_base_request::_(we_base_request::STRING_LIST, 'formats', [])));
			$this->we_doc->setElement($this->name . 'tinyparams', we_base_request::_(we_base_request::RAW_CHECKED, 'tinyparams', ''));
			$this->we_doc->setElement($this->name . 'templates', we_base_request::_(we_base_request::INTLIST, 'templates', ''));
			$this->we_doc->setElement($this->name . 'gallerytemplates', we_base_request::_(we_base_request::INTLIST, 'gallerytemplates', ''));
			$this->we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]);
			//$this->jsCmd->addCmd('object_TextArea_apply');

			$this->jsCmd->addCmd('object_changeTextareaParams_at_class', $we_transaction, $nr); //object_change_entry_at_class
			$this->jsCmd->addCmd('close');
		}
	}

	function elStatus($type){
		$offByDefault = ['dhtmledit', 'removefirstparagraph'];

		return $this->we_doc->getElement($this->name . $type, we_contents_base::ETYPE_TEXT, (in_array($type, $offByDefault) ? 'off' : 'on')) === 'on' ? 'on' : 'off';
	}

	public function show(){

// WYSIWYG && FORBIDHTML && FORBIDPHP
		$onOffVals = ['off' => 'false', 'on' => 'true'];

		$parts = [
			['headline' => 'wysiwyg',
				'html' => we_html_tools::select('dhtmledit', $onOffVals, 1, $this->elStatus('dhtmledit'), false, [], true, 60) . we_html_element::hidden('dhtmledit_orig', $this->we_doc->getElement($this->name . 'dhtmledit', we_contents_base::ETYPE_TEXT)),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'removefirstparagraph',
				'html' => we_html_tools::select('removefirstparagraph', $onOffVals, 1, $this->elStatus('removefirstparagraph'), false, [], true, 60),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'autobr',
				'html' => we_html_tools::select('autobr', $onOffVals, 1, $this->elStatus('autobr'), false, [], true, 60),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'inlineedit',
				'html' => we_html_tools::select('inlineedit', $onOffVals, 1, $this->elStatus('inlineedit'), false, [], true, 60) . we_html_element::hidden('inlineedit_orig', $this->we_doc->getElement($this->name . 'inlineedit', we_contents_base::ETYPE_TEXT)),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'showmenus',
				'html' => we_html_tools::select('showmenus', $onOffVals, 1, $this->elStatus('showmenus'), false, [], true, 60),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'width',
				'html' => we_html_tools::textInput('width', $this->we_doc->getElement($this->name . 'width'), 5, [], 'number', 60, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'height',
				'html' => we_html_tools::textInput('height', $this->we_doc->getElement($this->name . 'height'), 5, [], 'number', 60, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'class',
				'html' => we_html_tools::textInput('class', $this->we_doc->getElement($this->name . 'class'), 255, [], 'text', 400, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'bgcolor',
				'html' => we_html_tools::textInput('bgcolor', $this->we_doc->getElement($this->name . 'bgcolor'), 20, [], 'text', 60, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'commands',
				'html' => we_html_tools::select('tmp_commands', we_wysiwyg_editor::getEditorCommands(false), 1, '', false, ['onchange' => "var elem=document.getElementById('commands'); var txt = this.options[this.selectedIndex].text; if(elem.value.split(',').indexOf(txt)==-1){elem.value=(elem.value) ? (elem.value + ',' + txt) : txt;}this.selectedIndex=-1"]) . we_html_element::br() . we_contents_base::htmlTextArea('commands', 1, 30, oldHtmlspecialchars($this->we_doc->getElement($this->name . "commands")), [
					'id' => 'commands', 'style' => 'width:400px;height:4ex;']),
				'noline' => true,
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'contextmenu',
				'html' => we_html_tools::select('tmp_contextmenu', we_wysiwyg_editor::getEditorCommands(false), 1, '', false, ['onchange' => "var elem=document.getElementById('contextmenu'); var txt = this.options[this.selectedIndex].text; if(elem.value.split(',').indexOf(txt)==-1){elem.value=(elem.value) ? (elem.value + ',' + txt) : txt;}this.selectedIndex=-1"]) . we_html_element::br() . we_contents_base::htmlTextArea('contextmenu', 1, 30, oldHtmlspecialchars($this->we_doc->getElement($this->name . "contextmenu")), [
					'id' => 'contextmenu', 'style' => 'width:400px;height:4ex;']),
				'space' => we_html_multiIconBox::SPACE_MED2
			],
			['headline' => 'fontnames',
				'html' => we_html_tools::select('tmp_fontnames', we_wysiwyg_editor::getAttributeOptions('fontnames'), 1, '', false, ['onchange' => "var elem=document.we_form.fontnames; var txt = this.options[this.selectedIndex].text; if(elem.value.split(',').indexOf(txt)==-1){elem.value=(elem.value) ? (elem.value + ',' + txt) : txt;}this.selectedIndex=-1"]) . '<br/>' . we_html_tools::textInput('fontnames', $this->we_doc->getElement($this->name . 'fontnames'), 1024, [
], 'text', 400, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'fontsizes',
				'html' => we_html_tools::select('tmp_fontsizes', we_wysiwyg_editor::getAttributeOptions('fontsizes'), 1, '', false, ['onchange' => "var elem=document.we_form.fontsizes; var txt = this.options[this.selectedIndex].text; if(elem.value.split(',').indexOf(txt)==-1){elem.value=(elem.value) ? (elem.value + ',' + txt) : txt;}this.selectedIndex=-1"]) . we_html_element::br() . we_html_tools::textInput('fontsizes', $this->we_doc->getElement($this->name . 'fontsizes'), 1024, [
], 'text', 400, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'formats',
				'html' => we_html_tools::select('tmp_formats', we_wysiwyg_editor::getAttributeOptions('formats'), 1, '', false, ['onchange' => "var elem=document.we_form.formats; var txt = this.options[this.selectedIndex].text; if(elem.value.split(',').indexOf(txt)==-1){elem.value=(elem.value) ? (elem.value + ',' + txt) : txt;}this.selectedIndex=-1"]) . we_html_element::br() . we_html_tools::textInput('formats', $this->we_doc->getElement($this->name . 'formats'), 1024, [
], 'text', 400, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'classes',
				'html' => we_html_tools::textInput('cssClasses', oldHtmlspecialchars($this->we_doc->getElement($this->name . 'cssClasses')), 1024, [], 'text', 400, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'tinyparams',
				'html' => we_html_tools::textInput('tinyparams', $this->we_doc->getElement($this->name . 'tinyparams'), 1024, [], 'text', 400, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'templates',
				'html' => we_html_tools::textInput('templates', $this->we_doc->getElement($this->name . 'templates'), 1024, [], 'text', 400, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			], ['headline' => 'gallerytemplates',
				'html' => we_html_tools::textInput('gallerytemplates', $this->we_doc->getElement($this->name . 'gallerytemplates'), 1024, [], 'text', 400, 0),
				'space' => we_html_multiIconBox::SPACE_MED2
			]
		];

		$out = we_html_element::hidden('ok', 1);

		foreach($_REQUEST['we_cmd'] as $k => $v){
			$out .= we_html_element::hidden('we_cmd[' . $k . ']', $v);
		}

		return $this->getPage($out .
				we_html_multiIconBox::getHTML('', $parts, true, we_html_button::position_yes_no_cancel(we_html_button::create_button(we_html_button::OK, "javascript:document.forms[0].submit();"), null, we_html_button::create_button(we_html_button::CANCEL, "javascript:top.close()")), -1, '', '', '', g_l('modules_object', '[field][textarea]') . ' "' . $this->we_doc->getElement($this->name) . '" - ' . g_l('modules_object', '[attributes]'))
				, '', [
				'onload' => 'top.focus();',
				'onunload' => '',
				'class' => 'weDialogBody'], [
				'action' => getScriptName()
		]);
	}

}
