<?php

/**
 * webEdition CMS
 *
 * $Rev: 15870 $
 * $Author: mokraemer $
 * $Date: 2018-10-05 13:41:16 +0200 (Fri, 05 Oct 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_schedpro extends we_editor_base{

	public function show(){
		if(we_modules_info::isActive(we_modules_info::SCHEDULER)){
			we_schedule_scheduler::trigger_schedule();
		}
		$GLOBALS['we_transaction'] = we_base_request::_(we_base_request::TRANSACTION, 'we_cmd', we_base_request::_(we_base_request::TRANSACTION, 'we_transaction'), 2);

		$parts = [];

		foreach($this->we_doc->schedArr as $i => $sched){
			$schedObj = new we_schedule_scheduler($sched, $i);

			$parts[] = [
				'headline' => g_l('modules_schedule', '[task][headline]') . ' ' . ($i + 1),
				'html' => $schedObj->getHTML($this->jsCmd, $GLOBALS['we_doc']->Table === OBJECT_FILES_TABLE),
				'space' => we_html_multiIconBox::SPACE_MED
			];
		}
		$parts[] = [
			'headline' => '',
			'html' => we_html_tools::alertAttentionBox(g_l('modules_schedule', '[descriptiontext]'), we_html_tools::TYPE_INFO, 700) . '<br/><br/>' . we_html_button::create_button('fa:btn_add_schedule,fa-plus,fa-lg fa-clock-o', "javascript:we_cmd('schedule_add')"),
		];
		return $this->getPage(we_html_multiIconBox::getHTML('', $parts, true), we_schedule_scheduler::getMainJS($this->we_doc), [
				'onload' => "checkFooter();doScrollTo();"
		]);
	}

}
