<?php

/**
 * webEdition CMS
 *
 * $Rev: 15093 $
 * $Author: mokraemer $
 * $Date: 2018-03-21 12:07:05 +0100 (Wed, 21 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_thumbnail_tree extends we_tree_base{

	protected function customJSFile(){
		return we_html_element::jsScript(WE_JS_MODULES_DIR . 'mod_tree.js', "initTree('" . we_modules_info::THUMB . "');");
	}

	public static function getItems($ParentID, $offset = 0, $segment = 500, $sort = false){
		$db = new DB_WE();

		$items = [];
		$db->query('SELECT ID,Text,ParentID,IsFolder FROM ' . THUMBNAILS_TABLE . ' ORDER BY Text');

		while($db->next_record(MYSQLI_ASSOC)){
			$items[] = [
				'id' => intval($db->f('ID')),
				'parentid' => intval($db->f('ParentID')),
				'text' => addslashes($db->f('Text')),
				'typ' => $db->f('IsFolder') ? self::TYP_FOLDER : self::TYP_ITEM,
				'open' => 0,
				'isfolder' => $db->f('IsFolder'),
				'disabled' => 0,
				'tooltip' => $db->f('ID'),
				'offset' => $offset,
				'contenttype' => $db->f('IsFolder') ? we_base_ContentTypes::FOLDER : we_base_ContentTypes::THUMBNAIL,
				'published' => 1,
				'table' => THUMBNAILS_TABLE
			];
		}
		return $items;
	}

}
