<?php

/**
 * webEdition CMS
 *
 * $Rev: 15644 $
 * $Author: mokraemer $
 * $Date: 2018-08-26 13:48:35 +0200 (Sun, 26 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_addDelShopItem extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(!we_modules_info::isActive(we_modules_info::SHOP)){
			echo self::modulMissingError('Shop', __CLASS__);
			return '';
		}
		if(($foo = self::attributeMissing($attribs, 'shopname', __CLASS__))){
			return $foo;
		}

		$shopname = self::getAttribute('shopname', $attribs, '', we_base_request::STRING);
		$floatquantities = self::getAttribute('floatquantities', $attribs, false, we_base_request::BOOL);

		we_modules_info::isActive(we_modules_info::SHOP);

		$rShopname = we_base_request::_(we_base_request::STRING, 'shopname');
		if($rShopname == $shopname || !$rShopname){
			if(is_array(($cartIDs = we_base_request::_(we_base_request::HTML, 'shop_cart_id')))){
				if(we_base_request::_(we_base_request::INT, 't', 0) > (isset($_SESSION['tb']) ? $_SESSION['tb'] : 0 )){
					foreach($cartIDs as $cartId => $cartAmount){
						$GLOBALS[$shopname]->setCartItem(strip_tags($cartId), $floatquantities ? we_base_util::std_numberformat($cartAmount) : intval($cartAmount));
						$_SESSION[$shopname . '_save'] = $GLOBALS[$shopname]->getCartProperties();
					}
				}
				//FIXME: change to INT/FLOAT
			} else if(is_array($shopAnzahl = we_base_request::_(we_base_request::HTML, 'shop_anzahl_und_id'))){
				if(we_base_request::_(we_base_request::INT, 't', 0) > (empty($_SESSION['tb']) ? 0 : $_SESSION['tb'] )){
					$shop_articleid_variant = $shop_anzahl = '';
					foreach($shopAnzahl as $shop_articleid_variant => $shop_anzahl){
						$articleInfo = explode('_', strip_tags($shop_articleid_variant));
						$GLOBALS[$shopname]->setItem(intval($articleInfo[0]), ($floatquantities ? we_base_util::std_numberformat($shop_anzahl) : intval($shop_anzahl)), $articleInfo[1], (isset($articleInfo[2]) ? $articleInfo[2] : ''));
						$_SESSION[$shopname . '_save'] = $GLOBALS[$shopname]->getCartProperties();
						unset($articleInfo);
					}
					$_SESSION['tb'] = we_base_request::_(we_base_request::INT, 't', 0);
				}
			} else if(($artID = we_base_request::_(we_base_request::INT, 'shop_artikelid')) && ($shopAnz = we_base_request::_($floatquantities ? we_base_request::FLOAT : we_base_request::INT, 'shop_anzahl'))){
				if(we_base_request::_(we_base_request::INT, 't', 0) > (empty($_SESSION['tb']) ? 0 : $_SESSION['tb'] )){
					$GLOBALS[$shopname]->addItem($artID, $shopAnz, we_base_request::_(we_base_request::STRING, 'type'), we_base_request::_(we_base_request::HTML, we_base_variants::REQUEST, ''), we_base_request::_(we_base_request::STRING, we_shop_shop::ARTICLE_CUSTOM_FIELD, [
					]));
					$_SESSION[$shopname . '_save'] = $GLOBALS[$shopname]->getCartProperties();
					$_SESSION['tb'] = we_base_request::_(we_base_request::INT, 't');
				}
			} else if(($artID = we_base_request::_(we_base_request::INT, 'del_shop_artikelid'))){
				if(we_base_request::_(we_base_request::INT, 't', 0) > (isset($_SESSION['tb']) ? $_SESSION['tb'] : 0 )){
					$GLOBALS[$shopname]->delItem($artID, we_base_request::_(we_base_request::STRING, 'type'), (we_base_request::_(we_base_request::STRING, we_base_variants::REQUEST)), we_base_request::_(we_base_request::STRING, we_shop_shop::ARTICLE_CUSTOM_FIELD, [
					]));
					$_SESSION[$shopname . '_save'] = $GLOBALS[$shopname]->getCartProperties();
					$_SESSION['tb'] = we_base_request::_(we_base_request::INT, 't');
				}
			}
		}
		return '';
	}

}

function we_tag_addDelShopItem(array $attribs){
	return we_tag_addDelShopItem::tag($attribs);
}
