<?php

/**
 * webEdition CMS
 *
 * $Rev: 15664 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:56:44 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_category extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
// initialize possible Attributes
		$delimiter = self::getAttribute('delimiter', $attribs, self::getAttribute('tokken', $attribs, ',', we_base_request::RAW_CHECKED, true), we_base_request::RAW_CHECKED);
		$rootdir = self::getAttribute('rootdir', $attribs, '', we_base_request::FILE);
		$showpath = self::getAttribute('showpath', $attribs, false, we_base_request::BOOL);
		$docAttr = self::getAttribute('doc', $attribs, '', we_base_request::STRING);
		$field = self::getAttribute('field', $attribs, '', we_base_request::STRING);
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$id = self::getAttribute('id', $attribs, 0, we_base_request::INTLIST);
		$separator = self::getAttribute('separator', $attribs, '/', we_base_request::RAW_CHECKED);
		$onlyindir = self::getAttribute('onlyindir', $attribs, '', we_base_request::FILE);
		//fixme: what is that, and why this name
		$fromTag = self::getAttribute('fromTag', $attribs, 'category', we_base_request::STRING);
		$shopCatIDs = self::getAttribute('categoryids', $attribs, -1, we_base_request::INTLIST);
		// end initialize possible Attributes

		if($id){
			$catIDs = $id;
		} elseif($name){
			if($GLOBALS['we']['editmode'] && $name){
				$_REQUEST['we_' . $GLOBALS['we_doc']->Name . '_category[' . $name . ']'] = $GLOBALS['we_doc']->getElement($name);
				$attribs['name'] = 'we_' . $GLOBALS['we_doc']->Name . '_category[' . $name . ']';
				$attribs['type'] = 'request';
				$attribs['rootdir'] = $onlyindir;
				$attribs['fromTag'] = $fromTag;
				$doc = self::getDocForTag($docAttr, false);
				$attribs['categoryids'] = $fromTag === 'shopcategory' ? $shopCatIDs : $doc->Category;

				return we_tag('categorySelect', $attribs);
			}
			$catIDs = $GLOBALS['we_doc']->getElement($name);
		} elseif(we_tag_listview::$current && $docAttr === 'listview'){
			$catIDs = we_tag_listview::$current->f(we_listview_base::CATEGORY_FIELD);
		} else {
			$doc = self::getDocForTag($docAttr, false);
			$catIDs = $doc->Category;
		}
		$catIDs = implode(',', array_filter(array_map('intval', explode(',', $catIDs))));
		$category = array_filter(we_category_category::we_getCatsFromIDs($catIDs, $delimiter, $showpath, $GLOBALS['DB_WE'], $rootdir, $field, $onlyindir, true));

		if(!$category){
			return '';
		}

		foreach($category as &$cat){
			$cat = str_replace('/', $separator, $cat);
		}
		return implode($delimiter, $category);
	}

}

function we_tag_category(array $attribs){
	return we_tag_category::tag($attribs);
}
