<?php

/**
 * webEdition CMS
 *
 * $Rev: 15714 $
 * $Author: mokraemer $
 * $Date: 2018-09-05 15:22:25 +0200 (Wed, 05 Sep 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_categorySelect extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		return '<?php ob_start();?>' . $content . '<?= ' . we_weTag_parser::printTag('categorySelect', $attribs, 'ob_get_clean()', false, true) . '; ?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$isuserinput = empty($name);
		$name = $isuserinput ? 'we_ui_' . we_tag_form::$name . '_categories' : $name;

		$type = self::getAttributeR('type', $attribs, '', we_base_request::STRING);
		$rootdir = self::getAttributeR('rootdir', $attribs, '/', we_base_request::FILE);
		$firstentry = self::getAttributeR('firstentry', $attribs, '', we_base_request::STRING);
		$showpath = self::getAttributeR('showpath', $attribs, false, we_base_request::BOOL);
		$indent = self::getAttribute('indent', $attribs, '', we_base_request::RAW_CHECKED);
		$multiple = self::getAttribute('multiple', $attribs, false, we_base_request::BOOL);

		$catIDs = self::getAttributeR('categoryids', $attribs, -1, we_base_request::INTLIST);
		$fromTag = self::getAttributeR('fromTag', $attribs, false, we_base_request::STRING);

		$values = '';
		if($isuserinput && we_tag_form::$name){
			$objekt = isset($GLOBALS['we_object'][we_tag_form::$name]) ?
				$GLOBALS['we_object'][we_tag_form::$name] :
				(isset($GLOBALS['we_document'][we_tag_form::$name]) ?
				$GLOBALS['we_document'][we_tag_form::$name] :
				(isset($GLOBALS['we_doc']) ? $GLOBALS['we_doc'] :
				false));
			if($objekt){
				$values = $objekt->Category;
			}
			$valuesArray = id_to_path($values, CATEGORY_TABLE, $GLOBALS['DB_WE'], true);
		} elseif($type === 'request'){
			// Bug Fix #750
			$valuesArray = we_base_request::_(we_base_request::STRING_LIST, $name, []);
		} else {
			// Bug Fix #750
			$valuesArray = (isset($GLOBALS[$name]) ? (is_array($GLOBALS[$name]) ?
				$GLOBALS[$name] :
				explode(',', $GLOBALS[$name])) : []);
		}

		$attribs['name'] = $name;

		// Bug Fix #750
		if($multiple){
			$attribs['name'] .= '[]';
			$attribs['multiple'] = 'multiple';
		} else {
			$attribs = removeAttribs($attribs, ['size', 'multiple']);
		}

		$attribs = removeAttribs($attribs, [
			'showpath',
			'rootdir',
			'firstentry',
			'type',
			'shopCat',
			'categoryids',
			'fromTag',
			'field'
		]);

		$content = trim($content);
		if(!$content){
			if($firstentry){
				$content .= getHtmlTag('option', ['value' => ($fromTag === 'shopcategory' ? 0 : '')], $firstentry);
			}
			$db = $GLOBALS['DB_WE'];
			$dbfield = $showpath || $indent ? 'Path' : 'Text';
			$valueField = $fromTag ? 'ID' : 'Path';
			//$whereTag = !$fromTag ? '' : ($fromTag === 'shopcategory' ? ' AND IsFolder=0' : ' AND ID IN('. trim($catIDs, ',') .')');
			$whereTag = !$fromTag ? '' : ' AND ID IN(' . trim($catIDs, ',') . ')';

			$data = $db->getAllq('SELECT ID,Path,Text FROM ' . CATEGORY_TABLE . ' WHERE ' . ($rootdir === '/' ? 1 : ' Path LIKE "' . $db->escape(rtrim($rootdir, '/')) . '/%"') . $whereTag . ' ORDER BY ' . $dbfield);
			foreach($data as $cur){
				$deep = count(explode('/', $cur['Path'])) - 2;
				$field = ($rootdir && ($rootdir != '/') && $showpath ?
					preg_replace('|^' . preg_quote($rootdir, '|') . '|', '', $cur[$dbfield]) :
					$cur[$dbfield]);

				if($field){
					$content .= getHtmlTag('option', ['value' => $cur[$valueField],
						(in_array($cur[$valueField], $valuesArray) ? 'selected' : null) => 'selected'
						], str_repeat($indent, $deep) . $field);
				}
			}
		} else {
			foreach($valuesArray as $catPaths){
				if(stripos($content, '<option>') !== false){
					$content = preg_replace('/<option>' . preg_quote($catPaths) . '( ?[<\n\r\t])/i', '<option selected="selected">' . $catPaths . '${1}', $content);
				}
				$content = str_replace('<option value="' . $catPaths . '">', '<option value="' . $catPaths . '" selected="selected">', $content);
			}
		}

		return we_html_element::span(['class' => 'we we_category'], getHtmlTag('select', $attribs, $content, true));
	}

}

function we_tag_categorySelect(array $attribs, $content){
	return we_tag_categorySelect::tag($attribs, $content);
}
