<?php

/**
 * webEdition CMS
 *
 * $Rev: 15821 $
 * $Author: mokraemer $
 * $Date: 2018-09-26 16:20:53 +0200 (Wed, 26 Sep 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifObject extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$we_oid = self::getAttribute('id', $attribs, 0, we_base_request::INT);
		$classid = self::getAttribute('classid', $attribs, 0, we_base_request::INT);
		$parentid = self::getAttribute('parentid', $attribs, 0, we_base_request::INT);

		switch(true){
			case (we_tag_listview::$current instanceof we_listview_objectBase):
				$ret = true;
				$ret &= (!$classid || we_tag_listview::$current->f(we_listview_base::CLASS_FIELD) == $classid);
				$ret &= (!$we_oid || we_tag_listview::$current->f(we_listview_base::ID_FIELD) == $we_oid);
				$ret &= (!$parentid || we_tag_listview::$current->f(we_listview_base::PARENTID_FIELD) == $parentid);
				return $ret;
			case (we_tag_listview::$current instanceof we_listview_search):
				$tableid = we_tag_listview::$current->f(we_listview_base::CLASS_FIELD);
				$ret = $tableid > 0;
				$ret &= (!$classid || $tableid == $classid);
				$ret &= (!$we_oid || we_tag_listview::$current->f('oid') == $we_oid);
				$ret &= (!$parentid || we_tag_listview::$current->f(we_listview_base::PARENTID_FIELD) == $parentid);
				return $ret;
			default:
				$ret = !empty($GLOBALS['we_obj']);
				$ret &= (!$classid || $GLOBALS['we_obj']->TableID == $classid);
				$ret &= (!$we_oid || $GLOBALS['we_obj']->ID == $we_oid);
				$ret &= (!$parentid || $GLOBALS['we_obj']->ParentID == $parentid);

				return $ret;
		}
	}

}

function we_tag_ifObject(){
	return we_tag_ifObject::tag();
}
