<?php
/**
 * webEdition CMS
 *
 * $Rev: 15644 $
 * $Author: mokraemer $
 * $Date: 2018-08-26 13:48:35 +0200 (Sun, 26 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
we_modules_info::isActive(we_modules_info::SHOP);

abstract class we_tag_ifShopNotEmpty extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, 'shopname', __CLASS__))){
			echo $foo;
			return false;
		}

		$shopname = self::getAttribute('shopname', $attribs, '', we_base_request::STRING);
		$basket = isset($GLOBALS[$shopname]) ? $GLOBALS[$shopname] : '';
		if($basket){
			$items = $basket->getShoppingItems();
			return !empty($items);
		}
		return false;
	}

}

/**
 * This functions checks if the shops basket is not empty
 *
 * @param          $attribs                                array
 *
 * @return         bool
 */
function we_tag_ifShopNotEmpty(array $attribs){
	return we_tag_ifShopNotEmpty::tag($attribs);
}
