<?php

/**
 * webEdition CMS
 *
 * $Rev: 15663 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:01:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifShopVat extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(!we_shop_category::isCategoryMode()){
			if(($foo = self::attributeMissing($attribs, 'id', __CLASS__))){
				echo $foo;
				return false;
			}
			$id = self::getAttribute('id', $attribs, -1, we_base_request::INT);

			$vatId = (we_tag_listview::$current && we_tag_listview::$current->f(we_shop_shop::VAT_FIELD_NAME) ?
				we_tag_listview::$current->f(we_shop_shop::VAT_FIELD_NAME) :
				$GLOBALS['we_doc']->getElement(we_shop_shop::VAT_FIELD_NAME));


			if(!$vatId){
				$shopVat = we_shop_vats::getStandardShopVat();
				if($shopVat){
					$vatId = $shopVat->id;
				}
			}

			return ($id == $vatId);
		} else {
			$match = intval(self::getAttribute('match', $attribs, 0, we_base_request::INT));
			$field = self::getAttribute('field', $attribs, 'id', we_base_request::STRING);
			$lvOnly = self::getAttribute('lvOnly', $attribs, false, we_base_request::BOOL);

			if(we_tag_listview::$current){
				$catID = we_tag_listview::$current->f(we_shop_shop::CATEGORY_FIELD_NAME) ?: 0;
				$wedocCategory = we_tag_listview::$current->f(we_listview_base::CATEGORY_FIELD) ?: '';
			} elseif(!$lvOnly){
				$catID = $GLOBALS['we_doc']->getElement(we_shop_shop::CATEGORY_FIELD_NAME) ?: 0;
				$wedocCategory = $GLOBALS['we_doc']->Category ?: '';
			} else {
				return false;
			}
			$attribs['shopcategoryid'] = $catID;
			$attribs['wedoccategories'] = $wedocCategory;
			$vatField = we_tag('shopVat', $attribs);

			switch($field){
				case 'id':
					return $match === 0 ? boolval($vatField) : $match === intval($vatField);
				default:
					return boolval($vatField);
			}
		}
	}

}

function we_tag_ifShopVat(array $attribs){
	return we_tag_ifShopVat::tag($attribs);
}
