<?php

/**
 * webEdition CMS
 *
 * $Rev: 15714 $
 * $Author: mokraemer $
 * $Date: 2018-09-05 15:22:25 +0200 (Wed, 05 Sep 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_link extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(we_tag_linklist::$current){
			$only = self::getAttribute('only', $attribs, '', we_base_request::BOOL);
			$link = we_tag_linklist::$current->getLink();
			$linkcontent = we_tag_linklist::$current->getLinkContent();
			if($link || we_tag_linklist::$current->getAnchor()){
				return we_tag_linklist::$current->getLinktag($link, $attribs) . ($only ? '' : $linkcontent . '</a>');
			}
			return $linkcontent;
		}
		if(($foo = self::attributeMissing($attribs, 'name', __CLASS__))){
			return $foo;
		}
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$xml = self::getAttribute('xml', $attribs, XHTML_DEFAULT, we_base_request::BOOL);
		$text = self::getAttribute('text', $attribs, '', we_base_request::STRING);
		$imageid = self::getAttribute('imageid', $attribs, 0, we_base_request::INT);
		$id = self::getAttribute('id', $attribs, 0, we_base_request::INT);

		// check if target document exists (Bug #7167)
		if($id != 0 && (!f('SELECT 1,Published>0 AS isPublished FROM ' . FILE_TABLE . ' WHERE ID=' . intval($id)))){
			$id = 0;
		}
		if($imageid != 0 && (!f('SELECT 1 FROM ' . FILE_TABLE . ' WHERE ID=' . intval($imageid)))){
			$imageid = 0;
			$id = 0;
		}

		$attribs = removeAttribs($attribs, ['text', 'id', 'imageid', 'to', 'nameto', '_name_orig']);
		$link = we_unserialize($GLOBALS['we_doc']->getElement($name));

		if(!$GLOBALS['we']['editmode']){
			return $GLOBALS['we_doc']->getFieldLink($link, $attribs, false, empty($GLOBALS['we']['main']['doc']) ? $GLOBALS['we_doc']->ParentID : $GLOBALS['we']['main']['doc']->ParentID, empty($GLOBALS['we']['main']['doc']) ? $GLOBALS['we_doc']->Path : $GLOBALS['we']['main']['doc']->Path);
		}

		if(is_array($link)){
			if(!$link){
				$link = [
					'id' => (isset($id) ? $id : ''),
					'ctype' => ((!empty($imageid)) ? we_base_link::CONTENT_INT : we_base_link::CONTENT_TEXT),
					'img_id' => ((!empty($imageid) ) ? $imageid : ''),
					'type' => (isset($id) ? we_base_link::TYPE_INT : we_base_link::TYPE_EXT),
					'href' => (isset($id) ? '' : we_base_link::EMPTY_EXT),
					'text' => (!empty($imageid) ? (!empty($text) ? $text : g_l('global', '[new_link]')) : '')
				];

				// Link should only displayed if it's a preset link
				if($id || $imageid != 0 || $text){
					$_SESSION['weS']['WE_LINK'] = we_serialize($link, SERIALIZE_JSON);
					$GLOBALS['we_doc']->changeLink($name);
					$GLOBALS['we_doc']->saveInSession($_SESSION['weS']['we_data'][$GLOBALS['we_transaction']]);
				}
			}

			$img = new we_imageDocument();
			$content = we_contents_document::getLinkContent($link, $GLOBALS['we_doc']->ParentID, $GLOBALS['we_doc']->Path, $img, $xml);

			$startTag = we_contents_document::getLinkStartTag($link, $attribs, $GLOBALS['we']['main']['doc']->ParentID, $GLOBALS['we']['main']['doc']->Path, $img);

			$editbut = we_html_button::create_button(we_html_button::LINK_EDIT, "javascript:setScrollTo(); we_cmd('edit_link', '" . $name . "')");
			$delbut = we_html_button::create_button(we_html_button::TRASH, "javascript:setScrollTo(); we_cmd('delete_link', '" . $name . "')");

			return we_html_element::span(['class' => 'we we_link'], ($startTag ?: '') . ($content ?: $text) . ($startTag ? '</a>' : '') . $editbut . $delbut);
		}

		return '';
	}

}

function we_tag_link(array $attribs){
	return we_tag_link::tag($attribs);
}
