<?php

/**
 * webEdition CMS
 *
 * $Rev: 15663 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:01:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_linklist extends we_weTag_tag{
	public static $current = null;

	public static function parse(array $attribs, $content){
		return '<?php ' .
			we_weTag_parser::printTag('linklist', $attribs) . ';
while(we_tag_linklist::$current->next()){?>' . $content . '<?php } ' .
			we_weTag_parser::printTag('linklist', ['_type' => 'stop']) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		switch(self::getAttribute('_type', $attribs, '', we_base_request::STRING)){
			default:
				$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
				$hidedirindex = self::getAttribute('hidedirindex', $attribs, TAGLINKS_DIRECTORYINDEX_HIDE, we_base_request::BOOL);
				$objectseourls = self::getAttribute('objectseourls', $attribs, TAGLINKS_OBJECTSEOURLS, we_base_request::BOOL);
				if(($foo = self::attributeMissing($attribs, 'name', __CLASS__))){
					return $foo;
				}
				$isInListview = !empty(we_tag_listview::$current);

				$linklist = ($isInListview ? we_tag_listview::$current->f($name) : (isset($GLOBALS['we_doc']) ? $GLOBALS['we_doc']->getElement($name) : ''));

				$GLOBALS['we']['ll'] = self::$current = new we_base_linklist(we_unserialize($linklist), $hidedirindex, $objectseourls, $GLOBALS['we_doc']->Name, $attribs);
				self::$current->setName($name);
				return self::$current;
			case 'stop':
				if(isset($GLOBALS['we']['ll'])){//FIXME: due to old parser code, remove ($GLOBALS['we']['ll']) in 8.1
					self::$current->last();
					unset($GLOBALS['we']['ll']);
				}

				self::$current = null;
				return '';
		}
	}

}

function we_tag_linklist(array $attribs){
	return we_tag_linklist::tag($attribs);
}
