<?php

/**
 * webEdition CMS
 *
 * $Rev: 15663 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:01:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_metadata extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		if(($foo = self::attributeMissing($attribs, 'name', __CLASS__)) && self::attributeMissing($attribs, 'id', __CLASS__)){
			return $foo;
		}
		return '<?php if(' . we_weTag_parser::printTag('metadata', $attribs) . '){?>' . $content . '<?php } we_weTag_tag::post_listview();?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$id = self::getAttribute('id', $attribs, 0, we_base_request::INT);

		if(!$id && $name){
			$unique = md5(uniqid(__FILE__, true));
			$value = (we_tag_listview::$current ?
				we_tag_listview::$current->f($name) :
				// determine the id of the element
				($GLOBALS['we_doc']->getElement($name) ?:
				//can be href
				$GLOBALS['we_doc']->getElement($name . we_base_link::MAGIC_INT_LINK_ID, we_contents_base::ETYPE_NUMBER)
				)
				);

			// it is an id
			$id = (is_numeric($value) ? $value : 0);
		}

		if($id){
			$lv = new we_listview_document($unique, 1, 0, '', false, '', '', false, false, [], '', '', false, '', '', '', '', '', '', 'off', true, '', $id, '', false, false, 0);
			self::pre_listview($lv);
			return $lv->next_record();
		}
		//we need this to keep the stack synchronized
		self::pre_listview(new stdClass());
		return false;
	}

}

function we_tag_metadata(array $attribs){
	return we_tag_metadata::tag($attribs);
}
