<?php

/**
 * webEdition CMS
 *
 * $Rev: 15663 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:01:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_position extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){

		//	type is required !!!
		if(($missingAttrib = self::attributeMissing($attribs, 'type', __CLASS__))){
			echo $missingAttrib;
			return '';
		}

		//	here we get the needed attributes
		$reference = self::getAttribute('reference', $attribs, '', we_base_request::STRING);

		switch(($type = self::getAttribute('type', $attribs, '', we_base_request::STRING))){
			case 'listview' : //	inside a listview, we take direct global listview object
				$retPos = (we_tag_listview::$current->start + we_tag_listview::$current->count);
				break;
			case 'listdir' : //	inside a listview
				$retPos = we_tag_listdir::$position['position'];
				break;
			case 'linklist' : //	look in fkt we_tag_linklist and class we_linklist for details
				$missingAttrib = self::attributeMissing($attribs, 'reference', __CLASS__); // seperate because of #6890
				if($missingAttrib){
					echo $missingAttrib;
					return '';
				}
				foreach($GLOBALS['we_position'][$type] as $name => $arr){
					if(strpos($name, $reference) === 0 && is_array($arr)){
						$content = $arr;
						break;
					}
				}
				$retPos = (isset($content) && isset($content['position']) ? $content['position'] : 0);
				break;

			case 'block' : //	look in function we_tag_block for details
				//	first we must get right array !!!
				$missingAttrib = self::attributeMissing($attribs, 'reference', __CLASS__);
				if($missingAttrib){
					echo $missingAttrib;
					return '';
				}
				foreach($GLOBALS['we_position'][$type] as $name => $arr){
					if(strpos($name, $reference) === 0 && is_array($arr)){
						$content = $arr;
					}
				}
				$retPos = (isset($content) && $content['position'] ? $content['position'] : 0);
				break;
			default:
				return '';
		}

		//	convert to desired format
		switch(self::getAttribute("format", $attribs, 1, we_base_request::STRING)){
			case 'a' :
				return we_base_util::number2System($retPos);
			case 'A' :
				return strtoupper(we_base_util::number2System($retPos));
			default:
				return $retPos;
		}
	}

}

function we_tag_position(array $attribs){
	return we_tag_position::tag($attribs);
}
