<?php

/**
 * webEdition CMS
 *
 * $Rev: 15714 $
 * $Author: mokraemer $
 * $Date: 2018-09-05 15:22:25 +0200 (Wed, 05 Sep 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_subscribe extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$type = self::getAttribute('type', $attribs, 'email', we_base_request::STRING);
		$values = self::getAttribute('values', $attribs, [], we_base_request::STRING_LIST);
		$value = self::getAttribute('value', $attribs, '', we_base_request::RAW);
		$xml = self::getAttribute('xml', $attribs, XHTML_DEFAULT, we_base_request::BOOL);
		$checked = self::getAttribute('checked', $attribs, false, we_base_request::BOOL);

		switch($type){
			case 'listCheckbox':
				$nr = isset($GLOBALS['WE_TAG_SUBSCRIBE_LISTCHECKBOX_NR']) ? ($GLOBALS['WE_TAG_SUBSCRIBE_LISTCHECKBOX_NR'] + 1) : 0;
				$GLOBALS['WE_TAG_SUBSCRIBE_LISTCHECKBOX_NR'] = $nr;

				$newAttribs = removeAttribs($attribs, ['name', 'type', 'value']);

				$newAttribs['type'] = 'checkbox';
				$newAttribs['name'] = 'we_subscribe_list__[' . $nr . ']';
				$newAttribs['value'] = $nr;

				if($checked || (($list = we_base_request::_(we_base_request::HTML, 'we_subscribe_list__')) && in_array($nr, $list))){
					$newAttribs['checked'] = 'checked';
				}

				return we_html_element::span(['class' => 'we we_subscribe'], getHtmlTag('input', ['type' => 'hidden', 'name' => 'we_use_lists__', 'value' => 1, 'xml' => $xml]) .
						getHtmlTag('input', $newAttribs));

			case 'listSelect':
				if($values){
					$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'values', 'lists', 'maxlength', 'checked']);
					$newAttribs['name'] = 'we_subscribe_list__[]';
					$newAttribs['multiple'] = 'multiple';
					$options = '';
					foreach($values as $i => $v){
						$options .= (($list = we_base_request::_(we_base_request::HTML, 'we_subscribe_list__')) && in_array($i, $list) ?
							getHtmlTag('option', ['value' => $i + 1, 'selected' => 'selected'], oldHtmlspecialchars($v)) :
							getHtmlTag('option', ['value' => $i + 1], oldHtmlspecialchars($v)));
					}
					return we_html_element::span(['class' => 'we we_subscribe'], getHtmlTag('input', ['type' => 'hidden', 'name' => 'we_use_lists__', 'value' => 1, 'xml' => $xml]) .
							getHtmlTag('select', $newAttribs, $options, true));
				}
				return '';

			case 'htmlCheckbox':
				$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'checked', 'values']);
				$newAttribs['name'] = 'we_subscribe_html__';
				$newAttribs['type'] = 'checkbox';
				$newAttribs['value'] = 1;
				if($checked || we_base_request::_(we_base_request::BOOL, 'we_subscribe_html__')){
					$newAttribs['checked'] = 'checked';
				}
				return we_html_element::span(['class' => 'we we_subscribe'], getHtmlTag('input', $newAttribs));

			case 'htmlSelect':
				$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'size', 'values', 'maxlength', 'checked']);
				$newAttribs['name'] = 'we_subscribe_html__';
				$value = self::getAttribute('value', $attribs, false, we_base_request::BOOL);
				$ishtml = we_base_request::_(we_base_request::BOOL, 'we_subscribe_html__', (isset($attribs['value']) ? $value : false));
				$values = ($values ?: ['Text', 'HTML']);

				if($ishtml){
					$options = getHtmlTag('option', ['value' => 0], oldHtmlspecialchars($values[0])) .
						getHtmlTag('option', ['value' => 1, 'selected' => 'selected'], oldHtmlspecialchars($values[1]));
				} else {
					$options = getHtmlTag('option', ['value' => 0, 'selected' => 'selected'], oldHtmlspecialchars($values[0])) .
						getHtmlTag('option', ['value' => 1], oldHtmlspecialchars($values[1]));
				}
				return we_html_element::span(['class' => 'we we_subscribe'], getHtmlTag('select', $newAttribs, $options, true));

			case 'firstname':
				$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'values']);

				$newAttribs['type'] = 'text';
				$newAttribs['name'] = 'we_subscribe_firstname__';

				$newAttribs['value'] = we_base_request::_(we_base_request::HTML, "we_subscribe_firstname__", $value);

				return we_html_element::span(['class' => 'we we_subscribe'], getHtmlTag('input', $newAttribs));
			case 'salutation':
				if($values){
					$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'values', 'maxlength', 'checked']);
					$name = 'we_subscribe_salutation__';
					$value = we_base_request::_(we_base_request::HTML, 'we_subscribe_salutation__', $value);
					return we_html_element::span(['class' => 'we we_subscribe'], self::selectField($name, $value, $values, $newAttribs, true)); //same function like <we:sessionField type="select">
				}
				$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'values']);
				$newAttribs['name'] = 'we_subscribe_salutation__';
				$newAttribs['type'] = 'text';
				$newAttribs['value'] = we_base_request::_(we_base_request::HTML, 'we_subscribe_salutation__', $value);

				return we_html_element::span(['class' => 'we we_subscribe'], getHtmlTag('input', $newAttribs));

			case 'title':
				if($values){
					$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'values', 'maxlength', 'checked']);
					$name = 'we_subscribe_title__';
					$value = we_base_request::_(we_base_request::HTML, "we_subscribe_title__", $value);
					return we_html_element::span(['class' => 'we we_subscribe'], self::selectField($name, $value, $values, $newAttribs, true)); //same function like <we:sessionField type="select">
				}
				$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'values']);
				$newAttribs['name'] = 'we_subscribe_title__';
				$newAttribs['type'] = 'text';
				$newAttribs['value'] = we_base_request::_(we_base_request::HTML, "we_subscribe_title__", $value);

				return we_html_element::span(['class' => 'we we_subscribe'], getHtmlTag('input', $newAttribs));
			case 'lastname':
				$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'values']);
				$newAttribs['type'] = 'text';
				$newAttribs['name'] = 'we_subscribe_lastname__';
				$newAttribs['value'] = we_base_request::_(we_base_request::HTML, "we_subscribe_lastname__", $value);
				return we_html_element::span(['class' => 'we we_subscribe'], getHtmlTag('input', $newAttribs));

			case 'email':
			default:
				$newAttribs = removeAttribs($attribs, ['name', 'type', 'value', 'values']);
				$newAttribs['type'] = 'text';
				$newAttribs['name'] = 'we_subscribe_email__';
				$newAttribs['value'] = we_base_request::_(we_base_request::EMAIL, "we_subscribe_email__", $value);

				return we_html_element::span(['class' => 'we we_subscribe'], getHtmlTag('input', $newAttribs));
		}
	}

}

function we_tag_subscribe(array $attribs){
	return we_tag_subscribe::tag($attribs);
}
