<?php

/**
 * webEdition CMS
 *
 * $Rev: 15715 $
 * $Author: mokraemer $
 * $Date: 2018-09-05 15:54:58 +0200 (Wed, 05 Sep 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_textarea extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, 'name', __CLASS__))){
			return $foo;
		}
		$autobr = self::getAttribute('autobr', $attribs, false, we_base_request::BOOL);

		if($GLOBALS['we']['editmode']){
			$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
			$xml = self::getAttribute('xml', $attribs, XHTML_DEFAULT, we_base_request::BOOL);

			$removeFirstParagraph = self::getAttribute('removefirstparagraph', $attribs, defined('REMOVEFIRSTPARAGRAPH_DEFAULT') ? REMOVEFIRSTPARAGRAPH_DEFAULT : true, we_base_request::BOOL);

			$value = $GLOBALS['we_doc']->getElement($name) ?: $content;
			if((!$GLOBALS['we_doc']->getElement($name)) && $value){ // when not inlineedit, we need to save the content in the object, if the field is empty
				$GLOBALS['we_doc']->setElement($name, $value);
				$GLOBALS['we_doc']->saveInSession($_SESSION['weS']['we_data'][$GLOBALS['we_transaction']]);
			}
			//'we_' . $GLOBALS['we_doc']->Name . '_' . we_contents_base::INTERNAL_VAR . '[' . $name . '#autobr]'
			return we_html_element::span(['class' => 'we we_textarea'], we_html_forms::weTextarea('we_' . $GLOBALS['we_doc']->Name . '_txt[' . $name . ']', $value, $attribs, $autobr, '', false, false, $xml, $removeFirstParagraph, '', false, $name));
		}

		$txt = we_contents_document::parseInternalLinks($GLOBALS['we_doc']->getField($attribs), 0, '');
		$txt = ($autobr ? strtr($txt, [
				"\r" => '',
				"<br>\n" => "\n",
				"<br/>\n" => "\n",
				"<br />\n" => "\n",
				"<BR>\n" => "\n",
				"<BR/>\n" => "\n",
				"<BR />\n" => "\n",
				"\n" => we_html_element::br()]) :
			$txt);
		return we_wysiwyg_editor::parseGalleryTags($txt);
	}

}

function we_tag_textarea(array $attribs, $content){
	return we_tag_textarea::tag($attribs, $content);
}
