<?php

/**
 * webEdition CMS
 *
 * $Rev: 15663 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:01:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_tr extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		//NOTE: _type is an internal attribute.
		return '<?= ' . we_weTag_parser::printTag('tr', ['_type' => 'start']) . ';?>' . $content . '<?= ' . we_weTag_parser::printTag('tr', ['_type' => 'end']) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(empty(we_tag_listview::$current)){
			return self::parseError('not in lv', __CLASS__);
		}
		switch(self::getAttribute('_type', $attribs, '', we_base_request::STRING)){
			case 'start':
				return (we_tag_listview::$current->shouldPrintStartTR() ? getHtmlTag('tr', removeAttribs($attribs, ['_type']), '', false, true) : '');
			case 'end':
				return (we_tag_listview::$current->shouldPrintEndTR() ? '</tr>' : '');
		}
		return '';
	}

}

function we_tag_tr(array $attribs){
	return we_tag_tr::tag($attribs);
}
