<?php

/**
 * webEdition CMS
 *
 * $Rev: 15660 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 11:41:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_votingList extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		if(($foo = self::attributeMissing($attribs, 'name', __CLASS__))){
			return $foo;
		}

		$attribs['_type'] = 'start';
		return '<?php ' . we_weTag_parser::printTag('votingList', $attribs) . '; ?>' . $content . '<?php ' . we_weTag_parser::printTag('votingList', ['_type' => 'stop']) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(!we_modules_info::isActive(we_modules_info::VOTING)){
			echo self::modulMissingError('Voting', __CLASS__);
			return;
		}
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$groupid = self::getAttribute('groupid', $attribs, 0, we_base_request::INT);
		$rows = self::getAttribute('rows', $attribs, 0, we_base_request::INT);
		$desc = self::getAttribute('desc', $attribs, false, we_base_request::BOOL);
		$order = self::getAttribute('order', $attribs, 'PublishDate', we_base_request::STRING);
		$subgroup = self::getAttribute('subgroup', $attribs, false, we_base_request::BOOL);
		$version = self::getAttribute('version', $attribs, 1, we_base_request::INT);
		$offset = self::getAttribute('offset', $attribs, 0, we_base_request::INT);
		$type = self::getAttribute('_type', $attribs, '', we_base_request::STRING);
		$start = max(intval(we_base_request::_(we_base_request::INT, '_we_vl_start_' . $name, 0)), 0);

		switch($type){
			case 'start':
				$lv=new we_voting_list($name, $groupid, ($version > 0 ? ($version - 1) : 0), $rows, $offset, $desc, $order, $subgroup, $start);
				self::pre_listview($lv);
				break;
			case 'stop':
				self::post_listview();
				break;
		}
	}

}

function we_tag_votingList(array $attribs){
	return we_tag_votingList::tag($attribs);
}
